%define with_tests 0
%define with_maven 1

Summary:       An open source data binding framework for Java
Name:          castor
Version:       1.3.2
Release:       %mkrel 1
Epoch:         1
Group:         Development/Java
License:       BSD and MPLv1.1 and W3C
URL:           http://castor.codehaus.org
# svn export http://svn.codehaus.org/castor/castor/tags/castor-1.3.2/
# tar czf castor-1.3.2-src-svn.tar.gz castor-1.3.2
Source0:       castor-1.3.2-src-svn.tar.gz
Source1:       castor-1.3.1-script
Patch0:        castor-1.3.2-poms.patch
Patch1:        castor-1.3.2-no_castor-maven-plugin.patch
# codegen cpa schema xml generated source . castor-maven-plugin is not available (circular deps)
Patch2:        castor-1.3.2-generated_sources.patch
Patch3:        castor-1.3.2-build.patch
Patch4:        castor-1.3.1-CastorCodeGenTask.patch
Patch5:        castor-1.3.2-MANIFESTs.patch
# remove clover plugin
Patch6:        castor-1.3.2-castor-pom.patch

BuildRequires: java-devel
BuildRequires: jpackage-utils >= 0:1.5.16
BuildRequires: dos2unix
BuildRequires: codehaus-parent

BuildRequires: adaptx
BuildRequires: ant
BuildRequires: apache-commons-cli
BuildRequires: apache-commons-collections
BuildRequires: apache-commons-dbcp
BuildRequires: apache-commons-logging
BuildRequires: apache-commons-lang
BuildRequires: bea-stax
BuildRequires: cglib
BuildRequires: checkstyle
BuildRequires: dbunit
BuildRequires: derby
BuildRequires: easymock2
BuildRequires: geronimo-jta-1.0.1B-api
BuildRequires: glassfish-persistence-1.0b-api
BuildRequires: jakarta-oro
BuildRequires: jdbc-stdext
BuildRequires: jndi
BuildRequires: junit
BuildRequires: junit4
BuildRequires: ldapjdk >= 4.18-0.0.5
BuildRequires: liblog4j-java
BuildRequires: mockito
BuildRequires: mysql-connector-java
BuildRequires: postgresql-jdbc
BuildRequires: regexp >= 1.5-0.0.6
BuildRequires: tyrex
BuildRequires: velocity

%if %{with_maven}
BuildRequires: spring3-beans
BuildRequires: spring3-context
BuildRequires: spring3-jdbc 
BuildRequires: spring3-orm
BuildRequires: spring3-test

BuildRequires: jdepend-maven-plugin
BuildRequires: maven-changes-plugin
BuildRequires: maven-checkstyle-plugin
BuildRequires: maven-clean-plugin
BuildRequires: maven-compiler-plugin
BuildRequires: maven-deploy-plugin
BuildRequires: maven-install-plugin
BuildRequires: maven-jar-plugin
BuildRequires: maven-javadoc-plugin
BuildRequires: maven-plugin-castor
BuildRequires: maven-plugin-jxr
BuildRequires: maven-resources-plugin
BuildRequires: maven-site-plugin
BuildRequires: maven-source-plugin
BuildRequires: maven-surefire-plugin
BuildRequires: maven-surefire-provider-junit4
BuildRequires: maven-surefire-report-plugin
BuildRequires: taglist-maven-plugin
BuildRequires: maven-project
BuildRequires: javacc-maven-plugin
BuildRequires: maven-failsafe-plugin
# BuildRequires: sql-maven-plugin
# om.googlecode.maven-overview-plugin maven-overview-plugin 1.6
BuildRequires: ldapjdk
BuildRequires: mockejb >= 0.6-0.b2.2
BuildRequires: multithreadedtc
%endif

Requires:      adaptx
Requires:      ant
Requires:      apache-commons-cli
Requires:      apache-commons-lang
Requires:      apache-commons-logging
Requires:      bea-stax
Requires:      cglib
Requires:      geronimo-jta-1.0.1B-api
Requires:      glassfish-persistence-1.0b-api
Requires:      jakarta-oro
Requires:      jdbc-stdext
Requires:      jndi
Requires:      ldapjdk >= 4.18-0.0.5
Requires:      liblog4j-java
Requires:      maven-project
Requires:      oro
Requires:      regexp >= 1.5-0.0.6
Requires:      tyrex
Requires:      velocity
Requires:      xerces-j2
Requires:      %{name}-xml = %{epoch}:%{version}-%{release}

Requires:      jpackage-utils
BuildArch:     noarch

%description
Castor is an open source data binding framework for Java. It's basically
the shortest path between Java objects, XML documents and SQL tables.
Castor provides Java to XML binding, Java to SQL persistence, and more.

%package demo
Group:         Development/Java
Summary:       Demo for %{name}
Requires:      %{name} = %{epoch}:%{version}-%{release}
BuildRequires: tomcat6-servlet-2.5-api
Requires:      tomcat6-servlet-2.5-api

%description demo
Demonstrations and samples for %{name}.

%package xml
Group:         Development/Java
Summary:       XML support for %{name}
Requires:      %{name} = %{epoch}:%{version}-%{release}

%description xml
XML support for Castor

%package javadoc
Group:         Development/Java
Summary:       Javadoc for %{name}

%description javadoc
Javadoc for %{name}.

%package doc
Group:         Development/Java
Summary:       Documentation for %{name}

%description doc
Documentation for %{name}.

%prep
%setup -q
%patch0 -p1
%if !%{with_maven}
%patch1 -p1
%patch2 -p1
for i in `find . -iname "pom.xml"`; do sed -ie '/<parent>/,/<\/parent/ {d}' $i; done
sed -i "s|easymock.jar|easymock2.jar|" src/build.xml
rm examples/src/main/java/dsml/Test.java

%else
rm -r cpa/src/test/java/org/castor/cpa/persistence/sql/*
# req org.codehaus.castor spring-orm 2.1
sed -i "s|<module>jpa-extensions-it</module>|<!--module>jpa-extensions-it</module-->|" pom.xml
# build fails goal>xmlctf-text
sed -i "s|<module>xmlctf</module>|<!--module>xmlctf</module-->|" pom.xml
%endif
%patch3 -p1
%patch4 -p0

find . -name "*.jar" -exec rm -f {} \;
find . -name "*.class" -exec rm -f {} \;
find . -name "*.bat" -exec rm -f {} \;

mkdir -p bin/lib
# Fix for wrong-file-end-of-line-encoding problem
for i in `find src/doc -iname "*.css"`; do sed -i 's/\r//' $i; done
for i in `find src/doc -iname "*.xsd"`; do sed -i 's/\r//' $i; done
for i in `find src/doc -iname "*.dtd"`; do sed -i 's/\r//' $i; done
for i in `find src/doc -iname "*.pdf"`; do sed -i 's/\r//' $i; done
for i in `find src/doc -iname "*.htm"`; do sed -i 's/\r//' $i; echo "" >> $i; done
#sed -i 's/\r//' src/etc/README
sed -i 's/\r//' src/etc/*.LICENSE
sed -i 's/\r//' src/etc/CHANGELOG
sed -i 's/\r//' src/etc/VERSION
sed -i 's/Class-Path: xerces.jar jdbc-se2.0.jar jndi.jar jta1.0.1.jar//' src/etc/MANIFEST.MF
sed -i 's/Class-Path: xerces-J_1.4.0.jar commons-logging-1.1.jar//' src/etc/MANIFEST.XML.MF
sed -i 's/Class-Path: commons-logging.jar//' src/etc/MANIFEST.COMMONS.MF
sed -i 's,Class-Path: lib/castor-$VERSION$$RELEASE$.jar lib/commons-logging-1.1.jar lib/log4j-1.2.8.jar lib/xerces-J_1.4.0.jar lib/jta1.0.1.jar lib/cglib-full-2.0.2.jar lib/derby-10.1.2.1.jar,,' src/etc/MANIFEST.EXAMPLES.MF
sed -i 's/Class-Path: xerces-J_1.4.0.jar jdbc-se2.0.jar jndi_1.2.1.jar jta1.0.1.jar cglib-full-2.0.2.jar commons-logging-1.1.jar//' src/etc/MANIFEST.JDO.MF

sed -i 's/version=1.3.1/version=%{version}/' src/etc/VERSION

%if %{with_maven}
%patch5 -p1
for i in `find . -iname "MANIFEST.MF"`; do sed -i 's,$VERSION,%{version},' $i; done
%patch6 -p0
%endif
# fix the correct end of line encoding
find . -type f -exec dos2unix {} \;
# fix the source files contain characters outside of the ASCII set
native2ascii -encoding UTF8 ddlgen/src/main/java/org/castor/ddlgen/AbstractGenerator.java ddlgen/src/main/java/org/castor/ddlgen/AbstractGenerator.java
native2ascii -encoding UTF8 xml/src/main/java/org/exolab/castor/types/DateTimeBase.java xml/src/main/java/org/exolab/castor/types/DateTimeBase.java

%build
export GC_MAXIMUM_HEAP_SIZE="134217728"
%if %{with_maven}
  mvn-rpmbuild -Pcpatests -Dmaven.test.failure.ignore=true install javadoc:aggregate
%else
  export CLASSPATH=$(build-classpath cglib jndi geronimo-jta-1.0.1B-api junit junit4 ldapjdk oro regexp tomcat6-servlet-api commons-logging)
  CLASSPATH=$CLASSPATH:$(build-classpath postgresql derby/derby mysql-connector-java glassfish-persistence-1.0b-api tyrex jdbc-stdext)
  CLASSPATH=$CLASSPATH:$(build-classpath adaptx xerces-j2 checkstyle xalan-j2 xalan-j2-serializer)
  ant -buildfile src/build.xml release
%endif

%install
rm -rf %{buildroot}

install -d -m 755 %{buildroot}%{_javadir}
install -d -m 755 %{buildroot}%{_mavenpomdir}
%if !%{with_maven}

for m in codegen \
  core \
  ddlgen ; do

  install -m 644 $m/pom.xml %{buildroot}%{_mavenpomdir}/JPP-%{name}-$m.pom
  install -m 644 dist/%{name}-$m-%{version}.jar %{buildroot}%{_javadir}/%{name}-$m.jar
  %add_maven_depmap JPP-%{name}-$m.pom %{name}-$m.jar
done

install -m 644 dist/%{name}-%{version}-commons.jar %{buildroot}%{_javadir}/%{name}-commons.jar
install -m 644 dist/%{name}-anttasks-%{version}.jar %{buildroot}%{_javadir}/%{name}-anttasks.jar
install -m 644 dist/%{name}-jdo-%{version}.jar %{buildroot}%{_javadir}/%{name}-jdo.jar
install -m 644 dist/%{name}-xml-%{version}.jar %{buildroot}%{_javadir}/%{name}-xml.jar
install -m 644 dist/%{name}-xml-diff-%{version}.jar %{buildroot}%{_javadir}/%{name}-xml-diff.jar
install -m 644 dist/%{name}-xml-schema-%{version}.jar %{buildroot}%{_javadir}/%{name}-xml-schema.jar
install -m 644 dist/%{name}-examples-%{version}.jar %{buildroot}%{_javadir}/%{name}-examples.jar
install -m 644 examples/pom.xml %{buildroot}%{_mavenpomdir}/JPP-%{name}-examples.pom
%add_maven_depmap -f examples JPP-%{name}-examples.pom %{name}-examples.jar
install -m 644 dist/%{name}-examples-sources-%{version}.jar %{buildroot}%{_javadir}/%{name}-examples-sources.jar

%else

install -m 644 pom.xml %{buildroot}/%{_mavenpomdir}/JPP-%{name}.pom
%add_maven_depmap JPP-%{name}.pom

for m in codegen \
  core \
  cpactf \
  ddlgen \
  maven-plugins ; do

  install -m 644 $m/pom.xml %{buildroot}%{_mavenpomdir}/JPP-%{name}-$m.pom
  install -m 644 $m/target/%{name}-$m-%{version}.jar %{buildroot}%{_javadir}/%{name}-$m.jar
  %add_maven_depmap JPP-%{name}-$m.pom %{name}-$m.jar
done

install -m 644 anttask/target/%{name}-anttasks-%{version}.jar %{buildroot}%{_javadir}/%{name}-anttasks.jar
install -m 644 cpa/target/%{name}-jdo-%{version}.jar %{buildroot}%{_javadir}/%{name}-jdo.jar
install -m 644 diff/target/%{name}-xml-diff-%{version}.jar %{buildroot}%{_javadir}/%{name}-xml-diff.jar
install -m 644 schema/target/%{name}-xml-schema-%{version}.jar %{buildroot}%{_javadir}/%{name}-xml-schema.jar
install -m 644 xml/target/%{name}-xml-%{version}.jar %{buildroot}%{_javadir}/%{name}-xml.jar

install -m 644 xmlctf-framework/target/%{name}-testsuite-xml-framework-%{version}.jar \
  %{buildroot}%{_javadir}/%{name}-testsuite-xml-framework.jar
install -m 644 xmlctf-framework/pom.xml %{buildroot}%{_mavenpomdir}/JPP-%{name}-testsuite-xml-framework.pom
%add_maven_depmap JPP-%{name}-testsuite-xml-framework.pom %{name}-testsuite-xml-framework.jar

%endif

install -m 644 anttask/pom.xml %{buildroot}%{_mavenpomdir}/JPP-%{name}-anttasks.pom
%add_maven_depmap JPP-%{name}-anttasks.pom %{name}-anttasks.jar

install -m 644 cpa/pom.xml %{buildroot}%{_mavenpomdir}/JPP-%{name}-jdo.pom
%add_maven_depmap JPP-%{name}-jdo.pom %{name}-jdo.jar

install -m 644 diff/pom.xml %{buildroot}%{_mavenpomdir}/JPP-%{name}-xml-diff.pom
%add_maven_depmap -f xml JPP-%{name}-xml-diff.pom %{name}-xml-diff.jar
install -m 644 schema/pom.xml %{buildroot}%{_mavenpomdir}/JPP-%{name}-xml-schema.pom
%add_maven_depmap -f xml JPP-%{name}-xml-schema.pom %{name}-xml-schema.jar
install -m 644 xml/pom.xml %{buildroot}%{_mavenpomdir}/JPP-%{name}-xml.pom
%add_maven_depmap -f xml JPP-%{name}-xml.pom %{name}-xml.jar

%if !%{with_maven}
# examples (demo)
install -d -m 755 %{buildroot}%{_datadir}/%{name}/examples
cp -pr examples/build/classes/* %{buildroot}%{_datadir}/%{name}/examples
%endif

# javadoc
install -d -m 755 %{buildroot}%{_javadocdir}/%{name}-%{version}
%if !%{with_maven}
cp -pr build/doc/javadoc/* %{buildroot}%{_javadocdir}/%{name}-%{version}
%else
cp -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{version}
%endif

# do this last, since it will delete all build directories
export CLASSPATH=$(build-classpath log4j adaptx xalan-j2 xalan-j2-serializer)
ant -buildfile src/build.xml doc

install -d -m 755 %{buildroot}%{_bindir}
install -pm 755 %SOURCE1 %{buildroot}%{_bindir}/%{name}

%files
%defattr(0644,root,root,0755)
%doc src/etc/CHANGELOG
%attr(0755,root,root) %{_bindir}/%{name}
%{_javadir}/%{name}-anttasks.jar
%{_javadir}/%{name}-codegen.jar
%{_javadir}/%{name}-core.jar
%{_javadir}/%{name}-ddlgen.jar
%{_javadir}/%{name}-jdo.jar
%if %{with_maven}
%{_javadir}/%{name}-cpactf.jar
#%{_javadir}/%{name}-cpa-testcase.jar
%{_javadir}/%{name}-maven-plugins.jar
%{_javadir}/%{name}-testsuite-xml-framework.jar
%{_mavenpomdir}/JPP-%{name}.pom
%{_mavenpomdir}/JPP-%{name}-cpactf.pom
%{_mavenpomdir}/JPP-%{name}-maven-plugins.pom
%{_mavenpomdir}/JPP-%{name}-testsuite-xml-framework.pom
%else
%{_javadir}/%{name}-commons.jar
%endif
%{_mavenpomdir}/JPP-%{name}-anttasks.pom
%{_mavenpomdir}/JPP-%{name}-codegen.pom
%{_mavenpomdir}/JPP-%{name}-core.pom
%{_mavenpomdir}/JPP-%{name}-ddlgen.pom
%{_mavenpomdir}/JPP-%{name}-jdo.pom
%{_mavendepmapfragdir}/%{name}

%if !%{with_maven}
%files demo
%defattr(0644,root,root,0755)
%{_javadir}/%{name}-examples.jar
%{_javadir}/%{name}-examples-sources.jar
%{_datadir}/%{name}/examples
%{_mavenpomdir}/JPP-%{name}-examples.pom
%{_mavendepmapfragdir}/%{name}-examples
%endif

%files xml
%defattr(0644,root,root,0755)
%{_javadir}/%{name}-xml.jar
%{_javadir}/%{name}-xml-diff.jar
%{_javadir}/%{name}-xml-schema.jar
%{_mavenpomdir}/JPP-%{name}-xml-diff.pom
%{_mavenpomdir}/JPP-%{name}-xml-schema.pom
%{_mavenpomdir}/JPP-%{name}-xml.pom
%{_mavendepmapfragdir}/%{name}-xml

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}

%files doc
%defattr(0644,root,root,0755)
%doc build/doc/*


%changelog

* Sat Mar 03 2012 dmorgan <dmorgan> 1:1.3.2-1.mga2
+ Revision: 217070
- Remove ant build support, and only use the maven one

  + gil <gil>
    - update to 1.3.2

* Sun Dec 18 2011 dmorgan <dmorgan> 1:1.3.1-4.mga2
+ Revision: 184072
- Disable copy of Source1, this create pbs in install

* Sat Dec 03 2011 gil <gil> 1:1.3.1-3.mga2
+ Revision: 175644
- changed Requires log4j in liblog4j-java
- build fix
- build fixed
  enable maven cpatests profile
  rebuilt with mockejb 0.6-0.b2.2 support
- fix ldapjdk version/release

  + dmorgan <dmorgan>
    - Fix install of examples
    - Remove gcj support
    - Re enable maven build support
    - Re enable maven build support

* Sun Nov 27 2011 dmorgan <dmorgan> 1:1.3.1-2.mga2
+ Revision: 172814
- Disable maven , needed for maven-plugin-castor dep build loop
- Enable maven build support
- Adapt to mageia guidelines

  + gil <gil>
    - added castor-1.3.1-script
    - update to 1.3.1
    - update to 1.1.2.1
    - update to 0.9.6
    - update to 0.9.6

* Sat Jan 22 2011 dmorgan <dmorgan> 1:0.9.5-1.mga1
+ Revision: 31612
- Remove ending point in summary
- Downgrade to version 0.9.5 and fix build
- Remove wrong buildrequire
- Add  geronimo-jta as buildrequire
- Add java-rpmbuild as Buildrequire
- imported package castor


* Sat Sep 15 2007 Anssi Hannula <anssi@mandriva.org> 1.0.5-3mdv2008.0
+ Revision: 87266
- rebuild to filter out autorequires of GCJ AOT objects
- remove unnecessary Requires(post) on java-gcj-compat

* Sun Sep 09 2007 Pascal Terjan <pterjan@mandriva.org> 0:1.0.5-2mdv2008.0
+ Revision: 82837
- update to new version


* Sat Dec 16 2006 David Walluck <walluck@mandriva.org> 1.0.5-1mdv2007.0
+ Revision: 98055
- 1.0.5
- Import castor

* Sun Jun 18 2006 David Walluck <walluck@mandriva.org> 0.9.5-1.3mdv2007.0
- fix build classpath

* Sun Jun 04 2006 David Walluck <walluck@mandriva.org> 0.9.5-1.3mdv2007.0
- rebuild for libgcj.so.7
- aot-compile

* Wed Jan 18 2006 David Walluck <walluck@mandriva.org> 0:0.9.5-1.2mdk
- export OPT_JAR_LIST

* Sun Sep 11 2005 David Walluck <walluck@mandriva.org> 0:0.9.5-1.1mdk
- release

* Fri Jun 17 2005 Gary Benson <gbenson@redhat.com> 0:0.9.5-1jpp_1fc
- Build into Fedora.

* Sat Jun 11 2005 Gary Benson <gbenson@redhat.com>
- Remove jarfiles and classfiles from the tarball.

* Fri Jun 03 2005 Gary Benson <gbenson@redhat.com>
- Fix up (alleged) invalid characters in the documentation.

* Sat Jul 24 2004 Fernando Nasser <fnasser@redhat.com> 0:0.9.5-1jpp_3rh
- use servletapi5 instead of servletapi4

* Thu Mar 11 2004 Frank Ch. Eigler <fche@redhat.com> 0:0.9.5-1jpp_2rh
- try servletapi4 instead of servletapi3
- add example-servletapi4.patch.bz2

* Thu Mar 04 2004 Frank Ch. Eigler <fche@redhat.com> 0:0.9.5-1jpp_1rh
- RH vacuuming

